(* RL 09.02 
 testexamples for RatEq, equations with fractions

 Compiler.Control.Print.printDepth:=10; (*4 default*)
 Compiler.Control.Print.printDepth:=5; (*4 default*)
 trace_rewrite:=true;

 use"kbtest/rateq.sml";
 *)
"----------- rateq.sml begin--------";
"---------(1/x=5) ---------------------";
"--------- S.68, Bsp.: 40, ((x)/(x - 8) + (x - 8)/(x) = 26/5)---------------------";

val t = (term_of o the o (parse RatEq.thy)) "(1/b+1/x=1) is_ratequation_in  x";
val Some(t_, _) = rewrite_set_ RatEq.thy  false RatEq_prls t;
val result = term2str t_;
if result <>  "True"  then raise error "rateq.sml: new behaviour 1:" else ();

val t = (term_of o the o (parse RatEq.thy)) "(sqrt(x)=1) is_ratequation_in  x";
val Some(t_, _) = rewrite_set_ RatEq.thy  false RatEq_prls t;
val result = term2str t_;
if result <>  "False"  then raise error "rateq.sml: new behaviour 2:" else ();

val t = (term_of o the o (parse RatEq.thy)) "(x=-1) is_ratequation_in x";
val Some(t_,_) = rewrite_set_ RatEq.thy  false RatEq_prls t;
val result = term2str t_;
if result <>  "False"  then raise error "rateq.sml: new behaviour 3:" else ();

val t = (term_of o the o (parse RatEq.thy)) "(3 + x^^^2 + 1/(x^^^2+3)=1) is_ratequation_in x";
val Some(t_,_) = rewrite_set_ RatEq.thy  false RatEq_prls t;
val result = term2str t_;
if result <>  "True"  then raise error "rateq.sml: new behaviour 4:" else ();

val result = match_pbl ["equality (x=1)","solveFor x","solutions L"] 
                (get_pbt ["rational","univariate","equation"]); 
case result of NoMatch' _  => ()  | _ => raise error "rateq.sml: new behaviour: 5";

val result = match_pbl ["equality (3 + x^^^2 + 1/(x^^^2+3)=1)","solveFor x","solutions L"] 
                (get_pbt ["rational","univariate","equation"]); 
case result of Matches' _  => ()  | _ => raise error "rateq.sml: new behaviour: 6";


(*---------rateq---- 23.8.02 ---------------------*)
"---------(1/x=5) ---------------------";
val fmz = ["equality (1/x=5)","solveFor x","solutions L"];
(* refine fmz ["univariate","equation"];
   *)

val (dI',pI',mI') = ("RatEq.thy",["univariate","equation"],["no_met"]);
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
(* val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
   --------------------------------------- Refine_Tacitly*)
(*  nxt = ("Model_Problem",Model_Problem ["rational","univariate","equation"]) *)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(* val nxt = ("Subproblem",Subproblem ("RatEq.thy",["univariate","equation"])*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(* val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
   --------------------------------------- Refine_Tacitly*)
(*val nxt = ("Model_Problem", Model_Problem ["normalize","polynomial","univariate","equation"])*) 
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*val nxt = Apply_Method ["PolyEq", "normalize_poly"])*)

(* get_obj g_fmz pt [2];
   *)

val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(**** assoc_thm': 'all_left' not in 'RatEq.thy' (and parents)*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(* val nxt = ("Subproblem",  Subproblem ("PolyEq.thy",["polynomial","univariate","equation"]))*)



val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*  ("Model_Problem", Model_Problem ["degree_1","polynomial","univariate","equation"])*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(* "x = 1 / 5" *)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
if mout2str(f) = "Form' FormKF (~1,EdUndef,0,Nundef,([x = 1 / 5])" then () 
else  raise error "rateq.sml: new behaviour: [x = 1 / 5]";



(*---------((x)/(x - 8) + (x - 8)/(x) = 26/5)---------------------*)
"--------- S.68, Bsp.: 40, ((x)/(x - 8) + (x - 8)/(x) = 26/5)---------------------";
(*EP Schalk_II_p68_n40*)
val fmz = ["equality ((x)/(x - 8) + (x - 8)/(x) = 26/5)","solveFor x","solutions L"];
(* val fmz = ["equality (3+x= 9*x^^^4+((1+2*x)/x^^^2)^^^2 + 6*(x^^^2*((1+2*x)/x^^^2)))",
	   "solveFor x","solutions L"];*)

(* refine fmz ["univariate","equation"];
*)

val (dI',pI',mI') = ("RatEq.thy",["univariate","equation"],["no_met"]);
(*val p = e_pos'; 
val c = []; 
val (mI,m) = ("Init_Proof",Init_Proof (fmz, (dI',pI',mI')));
val (p,_,f,nxt,_,pt) = me (mI,m) p c EmptyPtree;*)
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(* nxt = ("Model_Problem",Model_Problem ["rational","univariate","equation"])*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(* nxt = ("Subproblem",Subproblem ("RatEq.thy",["univariate","equation"]))*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(* nxt = ("Model_Problem", Model_Problem ["normalize","polynomial","univariate","equation"])*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(* ("Subproblem", Subproblem ("PolyEq.thy",["polynomial","univariate","equation"])) *)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(* nxt = ("Model_Problem", Model_Problem
     ["abcFormula","degree_2","polynomial","univariate","equation"])*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(* "x = -2, x = 10" *)
if mout2str(f) = "Form' FormKF (~1,EdUndef,0,Nundef,([x = -2, x = 10])" then() 
else  raise error "rateq.sml: new behaviour: [x = -2, x = 10]";

"----------- rateq.sml end--------";
